local _, class = UnitClass("player")
if class ~= "DEATHKNIGHT" then
	return
end


mNameplates = LibStub("AceAddon-3.0"):NewAddon("mNameplates", "AceEvent-3.0", "AceConsole-3.0")
local mNameplates = mNameplates



local UIF
local LSM = LibStub("LibSharedMedia-3.0")
local AceGUI = LibStub("AceGUI-3.0")

function mNameplates:OnInitialize()
	local defaults = {
		profile = {
			Enabled = true,
		}
	}
	
	self.db  = LibStub("AceDB-3.0"):New("mMinimapDB", defaults, "Default")
	db = self.db.profile
	
	self:SetupLDB()
	
	self:SetEnabledState(db.Enabled)
end

function mNameplates:OnEnable()	
	self:RegisterChatCommand("mn", "ToggleConfig")
	
	local UIFSettings = {
		font = LibStub("LibSharedMedia-3.0"):Fetch("font", "accid"),
		fontSize = 16,
	}

	UIF = LibStub("AceGUI-Factory-1.0"):GetFactory("mNameplates", UIFSettings)
end

function mNameplates:OnDisable()
end


---------------------------------------------------
-- Events
---------------------------------------------------

---------------------------------------------------
-- Creation
---------------------------------------------------

---------------------------------------------------
-- Settings
---------------------------------------------------
function mNameplates:Applyettings()
end

---------------------------------------------------
-- Config
---------------------------------------------------
do	
	local function Callback(widget, event, ...)
	end

	function mNameplates:ToggleConfig()
		if not OptionsFrame then	
			local m = UIF:Frame("mNameplates")
			m:SetLayout("Fill")
			m:SetWidth(810)
			m:SetHeight(620)
			m:SetCallback("OnClose", function(widget)
				widget:ReleaseChildren()
				widget:Release()
				OptionsFrame = nil
			end)				
			m:Show()			
			OptionsFrame = m
			
			m = AceGUI:Create("ScrollFrame")
			m:SetLayout("Flow")
			OptionsFrame:AddChild(m)	
		end
	end

	function mNameplates:SetupLDB()
		local LDB = LibStub("LibDataBroker-1.1")
		if not LDB then return end
		
		local l = LDB:NewDataObject("mNameplates")
		l.type = "launcher"
		l.icon = [[Interface\Icons\Spell_DeathKnight_RuneTap]]
		l.tocname = "mNameplates"
		l.label = "mNameplates"
		l.OnClick = function(self, button)
			mNameplates:ToggleConfig()
		end
		l.OnTooltipShow = function(tt)
			tt:AddLine("mNameplates")
			tt:AddLine("Click to toggle configuration")
		end
		
		self.ldbojb = l
	end
end